
I hereby place this patch for qmail into the public domain.
You are free to modify it, distribute modified versions, etc.

Tino Reichardt

--- qmail-local.c	2013-10-03 11:02:42.000000000 +0200
+++ qmail-local-tr.c	2013-10-03 11:04:06.523416132 +0200
@@ -41,6 +41,7 @@
 void temp_qmail(fn) char *fn;
 { strerr_die5x(111,"Unable to open ",fn,": ",error_str(errno),". (#4.3.0)"); }
 
+int numforward;
 int flagdoit;
 int flag99;
 
@@ -260,33 +261,49 @@
   }
 }
 
-unsigned long mailforward_qp = 0;
-
 void mailforward(recips)
 char **recips;
 {
- struct qmail qqt;
- char *qqx;
- substdio ss;
- int match;
+ const char *sendmail = "/usr/lib/sendmail.postfix";
+ int child;
+ char **args = (char **) alloc((numforward + 2 + 1) * sizeof(char *));
+ int wstat;
+ stralloc sender_sa = {0};
+ int i;
 
  if (seek_begin(0) == -1) temp_rewind();
- substdio_fdbuf(&ss,read,0,buf,sizeof(buf));
+ if (!stralloc_copys(&sender_sa, "-f")) temp_nomem();
+ if (!stralloc_cats(&sender_sa, sender)) temp_nomem();
+ if (!stralloc_0(&sender_sa)) temp_nomem();
 
- if (qmail_open(&qqt) == -1) temp_fork();
- mailforward_qp = qmail_qp(&qqt);
- qmail_put(&qqt,dtline.s,dtline.len);
- do
+ switch(child = fork())
   {
-   if (getln(&ss,&messline,&match,'\n') != 0) { qmail_fail(&qqt); break; }
-   qmail_put(&qqt,messline.s,messline.len);
+   case -1:
+     temp_fork();
+   case 0:
+     /* just pipe to the sendmail of postfix ... */
+     args[0] = sendmail; args[1] = sender_sa.s; args[numforward + 2] = 0;
+     for (i = 0; i < numforward; i++) args[i + 2] = recips[i];
+     sig_pipedefault();
+     execv(*args,args);
+     strerr_die3x(111,"Unable to run /usr/lib/sendmail.postfix: ",error_str(errno),". (#4.3.0)");
+  }
+
+ wait_pid(&wstat,child);
+ if (wait_crashed(wstat))
+   temp_childcrashed();
+
+ /* no stralloc_free() here... but mail addys are not very long */
+ /* free(recip.s); */
+
+ switch(wait_exitcode(wstat))
+  {
+   case 100:
+   case 64: case 65: case 70: case 76: case 77: case 78: case 112: _exit(100);
+   case 0: break;
+   case 99: flag99 = 1; break;
+   default: _exit(111);
   }
- while (match);
- qmail_from(&qqt,ueo.s);
- while (*recips) qmail_to(&qqt,*recips++);
- qqx = qmail_close(&qqt);
- if (!*qqx) return;
- strerr_die3x(*qqx == 'D' ? 100 : 111,"Unable to forward message: ",qqx + 1,".");
 }
 
 void bouncexf()
@@ -425,12 +442,6 @@
  substdio_puts(subfdoutsmall,"+");
  substdio_put(subfdoutsmall,count_buf,fmt_ulong(count_buf,count_program));
  substdio_puts(subfdoutsmall,"\n");
- if (mailforward_qp)
-  {
-   substdio_puts(subfdoutsmall,"qp ");
-   substdio_put(subfdoutsmall,count_buf,fmt_ulong(count_buf,mailforward_qp));
-   substdio_puts(subfdoutsmall,"\n");
-  }
  substdio_flush(subfdoutsmall);
 }
 
@@ -453,7 +464,6 @@
  int j;
  int k;
  int fd;
- int numforward;
  char **recips;
  datetime_sec starttime;
  int flagforwardonly;
